import React, { useState, useEffect, useCallback, useRef } from 'react';
import { Spin, Button } from 'antd';
import ListCardItem from './ItemCard';
import { get, post } from '@/services';
import styles from './ItemCard.less';

const tip = 'loading...';
const ListCard = props => {
  const {
    ouid,
    searchWord,
    valueCallback,
    onCommit = () => {},
    itemObj,
  } = props;
  const [valueList, setValueList] = useState({});
  const [dataList, setdataList] = useState([]);
  const [loading, setLoading] = useState(true);

  const getValueCallback = useCallback((value, index) => {
    valueList[index] = value;
    setValueList({ ...valueList });
    valueCallback({ ...valueList });
  }, []);
  console.log(itemObj, 'itemObj');
  useEffect(() => {
    setLoading(true);
    const defaultConfig = {
      optionsList: [],
      title: '默认组',
      id: '',
    };
    // /Cityinterface/rest/services/OMS.svc/P_GetUserByStation
    //
    //  /Cityinterface/rest/services/OMS.svc/U_GetUserListForBatchOper
    get('/Cityinterface/rest/services/OMS.svc/W4_GetMenuByRoleWithLevel', {
      // OUID:ouid||'',
      // stationID: ouid || '',
      roleID: itemObj.roleID,
      subSystemValue: itemObj.subSystemValue,
      subSystemName: itemObj.subSystemValue,
      _version: 9999,
      _dc: new Date().getTime(),
    })
      .then(res => {
        const list = [];
        // eslint-disable-next-line no-unused-expressions
        res.success &&
          res.root.forEach(item => {
            list.push({ ...defaultConfig, ...item });
          });
        setdataList(list);
        setLoading(false);
      })
      .catch(err => {
        console.error(err);
        setLoading(false);
      });
  }, [ouid]);
  return (
    <div>
      {loading ? (
        <Spin
          size="large"
          spinning={loading}
          tip={tip}
          style={{
            position: 'absolute',
            top: '30%',
            left: '0',
            right: '0',
            bottom: '0',
          }}
        />
      ) : (
        <>
          {dataList.some(d => d.type === 'widgetUIPage') && (
            <ListCardItem
              {...{
                type: 'widgetGroup',
                searchWord,
                children: dataList.filter(d => d.type === 'widgetUIPage'),
                text: '地图组件',
                itemid: '9999',
              }}
              getValueCallback={getValueCallback}
              searchWord={searchWord}
            />
          )}
          {dataList &&
            dataList.length > 0 &&
            dataList
              .filter(d => d.type === 'widgetGroup')
              .map((item, index) => (
                <ListCardItem
                  {...item}
                  itemid={index}
                  key={`item${index}key`}
                  getValueCallback={getValueCallback}
                  searchWord={searchWord}
                  {...props}
                />
              ))}
        </>
      )}
      {true && !loading && dataList && (
        <div className={styles.btnBox}>
          <Button type="primary" onClick={() => onCommit(valueList)}>
            提交
          </Button>
        </div>
      )}
    </div>
  );
};

export default ListCard;
